<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetInfoByCodCnrResponse StructType
 * @subpackage Structs
 */
class GetInfoByCodCnrResponse extends AbstractStructBase
{
    /**
     * The Root
     * Meta information extracted from the WSDL
     * - ref: discount_type:Root
     * @var \StructType\Root
     */
    public $Root;
    /**
     * The Outcome
     * @var string
     */
    public $Outcome;
    /**
     * The NumRec
     * @var string
     */
    public $NumRec;
    /**
     * Constructor method for GetInfoByCodCnrResponse
     * @uses GetInfoByCodCnrResponse::setRoot()
     * @uses GetInfoByCodCnrResponse::setOutcome()
     * @uses GetInfoByCodCnrResponse::setNumRec()
     * @param \StructType\Root $root
     * @param string $outcome
     * @param string $numRec
     */
    public function __construct(\StructType\Root $root = null, $outcome = null, $numRec = null)
    {
        $this
            ->setRoot($root)
            ->setOutcome($outcome)
            ->setNumRec($numRec);
    }
    /**
     * Get Root value
     * @return \StructType\Root|null
     */
    public function getRoot()
    {
        return $this->Root;
    }
    /**
     * Set Root value
     * @param \StructType\Root $root
     * @return \StructType\GetInfoByCodCnrResponse
     */
    public function setRoot(\StructType\Root $root = null)
    {
        $this->Root = $root;
        return $this;
    }
    /**
     * Get Outcome value
     * @return string|null
     */
    public function getOutcome()
    {
        return $this->Outcome;
    }
    /**
     * Set Outcome value
     * @param string $outcome
     * @return \StructType\GetInfoByCodCnrResponse
     */
    public function setOutcome($outcome = null)
    {
        // validation for constraint: string
        if (!is_null($outcome) && !is_string($outcome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outcome, true), gettype($outcome)), __LINE__);
        }
        $this->Outcome = $outcome;
        return $this;
    }
    /**
     * Get NumRec value
     * @return string|null
     */
    public function getNumRec()
    {
        return $this->NumRec;
    }
    /**
     * Set NumRec value
     * @param string $numRec
     * @return \StructType\GetInfoByCodCnrResponse
     */
    public function setNumRec($numRec = null)
    {
        // validation for constraint: string
        if (!is_null($numRec) && !is_string($numRec)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numRec, true), gettype($numRec)), __LINE__);
        }
        $this->NumRec = $numRec;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetInfoByCodCnrResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
