<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TransferUserResponse StructType
 * @subpackage Structs
 */
class TransferUserResponse extends AbstractStructBase
{
    /**
     * The Outcome
     * @var string
     */
    public $Outcome;
    /**
     * Constructor method for TransferUserResponse
     * @uses TransferUserResponse::setOutcome()
     * @param string $outcome
     */
    public function __construct($outcome = null)
    {
        $this
            ->setOutcome($outcome);
    }
    /**
     * Get Outcome value
     * @return string|null
     */
    public function getOutcome()
    {
        return $this->Outcome;
    }
    /**
     * Set Outcome value
     * @param string $outcome
     * @return \StructType\TransferUserResponse
     */
    public function setOutcome($outcome = null)
    {
        // validation for constraint: string
        if (!is_null($outcome) && !is_string($outcome)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($outcome, true), gettype($outcome)), __LINE__);
        }
        $this->Outcome = $outcome;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TransferUserResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
